Marble Game | Venu Madhav Chitta


Marble Game | Venu Madhav Chitta
You are playing game, where you are expected to keep a SINGLE marble on 2 dimension grid. The grid already has some marbles present.  There are 2 basic rules to keep the marble at a particular location X,Y
  1. The location X, Y should be empty
  2. You can keep a marble at a particular location (X,Y), only if there is at least 1 marble to the North  (i.e., with the same x coordinate and a greater y coordinate), at least 1 marble to the South  (i.e., with the same x coordinate and a lesser y coordinate), at least 1 marble to the East (i.e., with a lesser x coordinate and the same y coordinate) and at least 1 marble to the West (i.e., with a greater x coordinate and the same y coordinate)
The bottom left grid is marked as (0, 0).Edge locations , where there aren't 4 possible sides aren't considered valid positions to keep the marble.Given a board configuration, print the maximum number of places where you can keep a new marble.
Input Format: 
First line has two integer N and K. N is the size of the NxN grid and K is the number of marbles already present in the grid. K lines follow, in which each line has 2 integers X and Y. (X, Y) is the position of the marble present. 
Output Format: 
One integer which is the total number of places where you can keep a marble. 
Limits. 
N <= 1000. K <= N*N
Example.Example to above Test Case
6 9
0 2
1 1
1 5
2 0
2 2
2 5
4 0
4 2
5 1

Output:
3
Explanation:
In the following diagram, the black marbles are the places where marbles are present already and blue ones are the list of places where you can place a new marble. 
Example 2
Input:
2 4
0 0
0 1
1 0
1 1

Output:
0

Explanation: 
This is a 2×2 grid, in which all 4 positions are already occupied. You can't keep any more marbles in this grid.

https://github.com/xieqilu/Qilu-leetcode/blob/master/B209.MarbleGame.cs
This is a very good problem. The brute force approach is obvious, for each cell in the board, we look for all the four  directions to check if there is at least one marble in each direction. But this would take us O(n^3) running time which is not efficient. So we need a better approach.

So what kind of information do we need to find all the cell that can be placed new marble? We need to find the longest distance between two existing marbles on each row and column. Then store the positions of these two marbles.
If there is less than two marbles on a row or column, then all  empty places on this row or column cannot be a qualified cell,  because at least one direction has no marble. 

After that, we just need to use the above information to find intersections of qulified rows and columns. And if the qualified cell is empty, we can put a marble on it.
For example:
If for row#2, we know the two marbles that have longest distance are (1,2) and (1,6). Then for all columns between y=3 and y=5, we check if 1 is in the range of the two x coordinates of that column. If for y=3, the two marbles are (0,3) and (4,3), then because 1 is between 0 and 4, we get an intersection which is (1,3). Then if there is no existing marble on (1,3), we can put a new cell on (1,3).

Solution:
Implement the above idea as follows:
1, Use two N*2 array to store positions of the two longest distanced marbles for each row and column.
2, In the X array, X[i][0] and X[i][1] store the y coordinates of the two marbles on the ith column.
The two positions are: (i,X[i][0]) and (i,X[i][1]).
3, In the Y array, Y[j][0] and Y[j][1] stores the x coordinates of the two marbles on the jth row.
The two positions are" (Y[j][0], j) and (Y[j][0], j).
4, Traverse the board and construct the X and Y array. We can do this in one pass because for each pair of i and j, we can
check two positions: (i,j) and (j,i). The initial value of X[i][0] is N and X[i][1] is -1 in case of there is less than two
existing marbles on this column. The same as Y array.
5, Then traverse X array, check X[i,0] and X[i,1], if there is less than two marbles, continue.
6, Then traverse j from X[i][0]+1 to X[i][1]-1, for each j, check Y[j,0] and Y[j,1]. If Y[j] has less than two marbles, continue.
7, Then check if i is between Y[j][0] and Y[j][1],if it is then  means the column and row has a intersection and
there is no existing marble on position (i,j), then we find a qualified cell and res++.
8, After the above work, return res.
Time complexity: O(n^2)   Space: O(n)
Construct the X and Y array: O(n^2)   Traverse the X and Y array to find intersection: O(n^2)
Overall: O(n^2)
And the space of X and Y array is O(2n) = O(n)
        //find number of positions to put new marble
        static int GetNumOfMarble(bool[,] board, int size){
            int[,] X = new int[size,2];
            int[,] Y = new int[size,2];
           
            for(int i=0;i<size;i++){
                int maxY=-1, minY=size, maxX=-1, minX=size;
                for(int j=0;j<size;j++){
                    if(board[i,j]==true){
                        maxY=Math.Max(maxY,j); //update maxY and minY
                        minY=Math.Min(minY,j);
                    }
                    if(board[j,i]==true){
                        maxX=Math.Max(maxX,j); //update maxX and minX
                        minX=Math.Min(minX,j);
                    }
                }
                X[i,0]=minY;
                X[i,1]=maxY;
                Y[i,0]=minX;
                Y[i,1]=maxX;
            }
            int res = 0;
            for(int i=0;i<size;i++){
                if(X[i,0]==size || X[i,0]==X[i,1]) //no marbles or only one marble for this i
                    continue;
                for(int j=X[i,0]+1;j<X[i,1];j++){  //only check j between x[i,0]+1 and x[i,1]-1, inclusive
                    if(Y[j,0]==size || Y[j,0]==Y[j,1]) //no marbles or only one marble for this j
                        continue;
                    if(i>=Y[j,0]&&i<=Y[j,1]&&board[i,j]!=true) //if there is intersection and it's empty
                        res++;
                }
            }
            return res;          
        }
        //Parse STDIN
        static int[] ParseInput(string line){
            string[] input = line.Split();
            int[] nums = input.Select(y=>int.Parse(y)).ToArray();
            return nums;
        }
       
        static void Main(string[] args) {
            /* Enter your code here. Read input from STDIN. Print output to STDOUT */
            int[] firstLine = ParseInput(Console.ReadLine());
            int size = firstLine[0], numMarble = firstLine[1];
            bool[,] board = new bool[size,size];
            for(int i=0;i<numMarble;i++){
                int[] position = ParseInput(Console.ReadLine());
                board[position[0],position[1]] = true; //true means this position has marble
            }
            Console.WriteLine(GetNumOfMarble(board, size));
        }
    }

int calcOutput(bool ** containsMarbel,int n)
{
   bool ** matrix = new bool*[n];
   for (int i=0;i<n;i++)
        matrix[i]=new bool[n];
    for (int i=0;i<n;i++)
        for (int j=0;j<n;j++)
             matrix[i][j]=false;         
    for (int i=0;i<n;i++)
    {
        int x1=-1,y1=-1;
        for (int j=0;j<n;j++)
            if (x1==-1 && containsMarbel[j][i]==1)
                x1=j+1;
            else if (containsMarbel[j][i]==1)
                y1=j+1;
        if (x1!=-1&&y1!=-1)
            for (int j=x1;j<y1-1;j++)
              if (containsMarbel[j][i]!=1)
                 matrix[j][i]=1;
    }
    int count=0;
     for (int i=0;i<n;i++)
     {
        int x1=-1,y1=-1;
        for (int j=0;j<n;j++)
            if (x1==-1 && containsMarbel[i][j]==1)
                x1=j+1;
            else if (containsMarbel[i][j]==1)
                y1=j+1;
        if (x1!=-1&&y1!=-1)
            for (int j=x1;j> n>>k;
   bool ** containsMarbel = new bool*[n];
   for (int i=0;i<n;i++)
        containsMarbel[i]=new bool[n];
    for (int i=0;i<n;i++)
        for (int j=0;j<n;j++)
             containsMarbel[i][j]=false;
    
    for (int i=0;i>p>>q;
        containsMarbel[p][q]=true;
    }
    cout << calcOutput(containsMarbel,n);
    return 0;
}
Read full article from Marble Game | Venu Madhav Chitta

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts